''Control of messages.

CON
   
'' VMUSIC2 module Pin assignments  
  _TXPin = 8                                           'Propeller outputs serial data on pin  6 
  _RXPin = 10                                           'Unused

 
''UART or RS232 serial data parameters                
  _Serialmode = 0                                      'normalmode = 0
  _Baudrate = 9600                                     'shift levels 9600 times per sec (9600bps)

  k = 10
   
OBJ
   
  Oled  : "uOLED-128-GMD1"
  DELAY : "Clock"  
  Serie : "FullDuplexSerialMod"
  
VAR
  byte  msgs[250]
  byte  Line[8]
  byte  SAddr[2]
  long  seg
  long  tmin
  long  diff
  long  segant
  long  Stack[50]
  long  cogon, cog
  long  i
  long  j
  long  l
  long  state
  
PUB Mstart(data) : okay


  Oled.INIT                       
  DELAY.PauseSec(1)

  OLED.ERASE
  DELAY.PauseMSec(20)
  OLED.BACKGROUND(0,0,0)
  Oled.OPAQUE

  Serie.start(_TXPin,_RXPin,_Serialmode,_Baudrate)

  stop
  cogon := (cog := cognew(pMensa(data), @Stack)) > 0


PUB stop

'' Unload object - frees a cog

  if cogon~                                         ' if object running, mark stopped
    cogstop(cog)                                    ' stop the cog



PUB pMensa(data)  | count, temp

count := 0
state := 0

           Oled.CONTRAST(15)
           SAddr[0] := 64
           SAddr[1] := 22
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
           Oled.TRANSPARENT
           Oled.FTEXT(2,1, 2, 255,255,255, string("BTX Sistemas"),0)
           Oled.FTEXT(4,2, 2, 255,255,255, string("Repro Mp3"),0)
           Oled.FTEXT(2,13, 0, 255,255,255, string("By Alberto Geraci"),0)
           Oled.OPAQUE
           waitcnt(clkfreq*4 + cnt)
           Oled.ERASE
           Serie.rxflush
           Oled.FTEXT(2,1, 2, 255,255,255, string("BTX Sistemas"),0)
           Oled.FTEXT(4,2, 2, 255,255,255, string("Repro Mp3"),0)
           Oled.FTEXT(0,6, 0, 255,0,0, string("Mp3 en Stop"),0)     
           Oled.FTEXT(0,8, 0, 255,255,0, string("  Oprima  Play para"),0)
           Oled.FTEXT(0,9, 0, 255,255,0, string("      continuar"),0)
           
repeat

  If long[data][0] == 1 and count < 2*k
     Oled.FTEXT(0,12, 0, 255,255,0, string("Repeat Activado"),0)             'Repeat Play'
  If long[data][0] == 0 and count < 2*k
     Oled.FTEXT(0,12, 0, 255,255,0, string("               "),0)             'Repeat'
  If long[data][1] == 1 and count < 2*k
     Oled.FTEXT(0,12, 0, 255,255,0, string("Random Activado"),0)             'Random Play'

  Case long[data][2]
       0:
          If state == 1
             OLED.ON
             state := 0
       1:
          If state == 0
             OLED.OFF
             state := 1 
       
  count++
  Case count
       k+5:
           Oled.SCROLL_ENABLE(1)
           Oled.SCROLL_SPEED(1)
           Oled.CONTRAST(4)
       2*k:
           Oled.SCROLL_ENABLE(0)
           Oled.CONTRAST(15)
           SAddr[0] := 64
           SAddr[1] := 22
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
           Oled.TRANSPARENT
           Oled.FTEXT(2,1, 2, 255,255,255, string("BTX Sistemas"),0)
           Oled.FTEXT(4,2, 2, 255,255,255, string("Repro Mp3"),0)
           Oled.FTEXT(2,13, 0, 255,255,255, string("By Alberto Geraci"),0)
           Oled.OPAQUE

       3*k:
           SAddr[0] := 0                                    ' All SAddr are the addresses of the pictures in the Oled SD card.
           SAddr[1] := 16
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       4*k:
           SAddr[0] := 64
           SAddr[1] := 16
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       5*k:
           SAddr[0] := 128
           SAddr[1] := 16
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       6*k:
           SAddr[0] := 192
           SAddr[1] := 16
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       7*k:
           SAddr[0] := 0
           SAddr[1] := 17
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       8*k:
           SAddr[0] := 64
           SAddr[1] := 17
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       9*k:
           SAddr[0] := 128
           SAddr[1] := 17
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       10*k:
           SAddr[0] := 192
           SAddr[1] := 17
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       11*k:
           SAddr[0] := 0
           SAddr[1] := 18
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       12*k:
           SAddr[0] := 64
           SAddr[1] := 18
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       13*k:
           SAddr[0] := 128
           SAddr[1] := 18
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       14*k:
           SAddr[0] := 192
           SAddr[1] := 18
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       15*k:
           SAddr[0] := 0
           SAddr[1] := 19
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       16*k:
           SAddr[0] := 64
           SAddr[1] := 19
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       17*k:
           SAddr[0] := 128
           SAddr[1] := 19
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       18*k:
           SAddr[0] := 192
           SAddr[1] := 19
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       19*k:
           SAddr[0] := 0
           SAddr[1] := 20
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       20*k:
           SAddr[0] := 64
           SAddr[1] := 20
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       21*k:
           SAddr[0] := 128
           SAddr[1] := 20
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       22*k:
           SAddr[0] := 192
           SAddr[1] := 20
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       23*k:
           SAddr[0] := 0
           SAddr[1] := 21
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       24*k:
           SAddr[0] := 64
           SAddr[1] := 21
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       25*k:
           SAddr[0] := 128
           SAddr[1] := 21
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       26*k:
           SAddr[0] := 192
           SAddr[1] := 21
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       27*k:
           SAddr[0] := 0
           SAddr[1] := 22
           SAddr[2] := 0
           Oled.DISPLAY_FROM_uSD(0,0, 128,128, 16, @SAddr)
       28*k:
           count := (2*k)-1
      
  repeat i from 0 to 50                            'Recieve all characters sent by the VMUSIC2 until $0D is sent.
    msgs[i] := Serie.rx
    If msgs[i] == $0D
           j := i 
           quit     

  If msgs[i-1] == 62 and msgs[i-2] == 92            'Avoid show the "D:\" message
     msgs[0] := 32 
     i := 0
     next
     
  repeat i from 0 to 6                              'Copy some text in this vector
     Line[i] := msgs[i]
  Line[7] := 0   
  If strcomp(@Compare, @Line)                       'Compare strings to get jump at correct rutine
     l := 0

  If strcomp(@Compare2, @Line)
     l := 7

  If strcomp(@Compare3, @Line)
     l := 12

  Case l
      0:
        seg := 0
        tmin := 0
        segant := 0
        count := 0
        Oled.SCROLL_ENABLE(0)
        Oled.CONTRAST(15)
        OLED.ERASE
        repeat i from 0 to j-1
         if msgs[i] <> 13 
            OLED.FCHAR (msgs[i], i, 0, 255,255,0)
        l++
      1:
        Oled.FTEXT(0,1, 0, 255, 255, 0, string("Track: "),0)
        If j == 0
            Oled.FTEXT(7,1, 0, 0, 0, 128, string("Desconocido"),0)
        repeat i from 0 to j
         if msgs[i] <> 13 
            OLED.FCHAR (msgs[i], i+6, 1, 255,255,0)
        l++

      2:
        If j == 0
           Oled.FTEXT(0,2, 0, 0, 0, 128, string("No hay Info"),0)
        repeat i from 0 to j
         if msgs[i] <> 13 
            OLED.FCHAR (msgs[i], i, 2, 255,255,0)
        l++

      3:
        If j == 0
           Oled.FTEXT(0,3, 0, 0, 0, 128, string("No hay Info"),0)
        repeat i from 0 to j
         if msgs[i] <> 13 
            OLED.FCHAR (msgs[i], i, 3, 255,255,0)
        l++

      4:
        If j == 0
           Oled.FTEXT(0,4, 0, 0, 0, 128, string("No hay Info"),0)
        repeat i from 0 to j
         if msgs[i] <> 13 
            OLED.FCHAR (msgs[i], i, 4, 255,255,0)
        l++

      5:
        If j == 0
           Oled.FTEXT(0,5, 0, 0, 0, 128, string("No hay Info"),0)
        repeat i from 0 to j
         if msgs[i] <> 13 
            OLED.FCHAR (msgs[i], i, 5, 255,255,0)
        l++

      6:
        If count < k+5   
          Oled.FTEXT(0,6, 0, 255, 0, 0, string("Time "),0)
        else
          Oled.FTEXT(0,15, 0, 100, 0, 0, string("Time "),0)
        
        if msgs[2] => segant                        'Process the elapse time of a song, get the correct time although FF or REW is pressed
          diff := msgs[2] - segant
          seg := seg + diff
          if seg > 59 and seg < 70
             seg := seg - 60
             tmin++

        if msgs[2] < segant
          diff := segant - msgs[2] 
          seg := seg - diff
          if seg =< 0
             seg := seg + 60
             tmin--

        segant := msgs[2]
        
        if tmin == 60
           seg := 0
           tmin := 0

        if seg > 60
           seg := 0
             tmin++

        If count < k+5   

          if tmin < 10                                'Show the elapse time.
             Oled.FTEXT(5,6, 0, 255, 0, 0, string("0"),0)
             Oled.FTEXT(6,6, 0, 255, 0, 0, tmin,1)
             Oled.FTEXT(7,6, 0, 255, 0, 0, string(" Min : "),0)
          else
             Oled.FTEXT(5,6, 0, 255, 0, 0, tmin,1)
             Oled.FTEXT(7,6, 0, 255, 0, 0, string(" Min : "),0)
           
          if seg < 10
             Oled.FTEXT(14,6, 0, 255, 0, 0, string("0"),0)
             Oled.FTEXT(15,6, 0, 255, 0, 0, seg,1)
             Oled.FTEXT(16,6, 0, 255, 0, 0, string(" Seg"),0)
          else
             Oled.FTEXT(14,6, 0, 255, 0, 0, seg,1)
             Oled.FTEXT(16,6, 0, 255, 0, 0, string(" Seg"),0)

        else   

          if tmin < 10                                'Show the elapse time.
             Oled.FTEXT(5,15, 0, 100, 0, 0, string("0"),0)
             Oled.FTEXT(6,15, 0, 100, 0, 0, tmin,1)
             Oled.FTEXT(7,15, 0, 100, 0, 0, string(" Min : "),0)
          else
             Oled.FTEXT(5,15, 0, 100, 0, 0, tmin,1)
             Oled.FTEXT(7,15, 0, 100, 0, 0, string(" Min : "),0)
           
          if seg < 10
             Oled.FTEXT(14,15, 0, 100, 0, 0, string("0"),0)
             Oled.FTEXT(15,15, 0, 100, 0, 0, seg,1)
             Oled.FTEXT(16,15, 0, 100, 0, 0, string(" Seg    "),0)
          else
             Oled.FTEXT(14,15, 0, 100, 0, 0, seg,1)
             Oled.FTEXT(16,15, 0, 100, 0, 0, string(" Seg    "),0)
           
        l := 6

      7:
'         OLED.ERASE
'         Oled.FTEXT(3,1, 2, 255,255,255, string("BTX Sistemas"),0)
'         Oled.FTEXT(5,2, 2, 255,255,255, string("Repro Mp3"),0)
'        repeat i from 0 to j
'          OLED.FCHAR (msgs[i], i, 3, 255,255,0)
        l++
      8:
'        repeat i from 0 to j
'          OLED.FCHAR (msgs[i], i, 4, 255,255,0)
        l++
      9:
'        repeat i from 0 to j
'          OLED.FCHAR (msgs[i], i, 5, 255,255,0)
        l++
      10:
'        repeat i from 0 to j
'          OLED.FCHAR (msgs[i], i, 6, 255,255,0)
        l := 0

      12:
         count := 0
         Oled.SCROLL_ENABLE(0)
         Oled.CONTRAST(15)
         OLED.ERASE
         Oled.FTEXT(2,1, 2, 255,255,255, string("BTX Sistemas"),0)          ' Messages in Spanish
         Oled.FTEXT(4,2, 2, 255,255,255, string("Repro Mp3"),0)                   'MP3 Player'
         Oled.FTEXT(0,6, 0, 255,0,0, string("Mp3 en Stop"),0)     
         Oled.FTEXT(0,8, 0, 255,255,0, string("  Oprima  Play para"),0)     ' Press Play to'
         Oled.FTEXT(0,9, 0, 255,255,0, string("      continuar"),0)             'continue'
         Oled.FTEXT(2,15, 0, 255,255,255, string("By Alberto Geraci"),0)
         l := 0
          If long[data][0] == 1 and count < 2*k
             Oled.FTEXT(0,12, 0, 255,255,0, string("Repeat Activado"),0)             'Repeat'
          If long[data][0] == 0 and count < 2*k
             Oled.FTEXT(0,12, 0, 255,255,0, string("               "),0)             'Repeat'
          If long[data][1] == 1 and count < 2*k
             Oled.FTEXT(0,12, 0, 255,255,0, string("Random Activado"),0)             'Repeat'
           
         waitcnt(clkfreq + cnt)
         Oled.SCROLL_ENABLE(1)
         Oled.CONTRAST(4)
         
DAT                                                 'Strings to compare
Compare   byte "Playing",0
Compare2  byte "Ver 03.",0
Compare3  byte "Stopped",0
   