  ''Control the VMUSIC2 module by sending UART messages to it.

CON
   
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

'' VMUSIC2 module control character assignments  
  _CR = 13                                             'CR ends a string of serial data
  _LF = 10
  
'' VMUSIC2 module Pin assignments  
  _TXPin = 8                                           'Propeller outputs serial data on pin  0 
  _RXPin = 9                                           'Propeller receives serial data on pin 1

 
''UART or RS232 serial data parameters                
  _Serialmode = 0                                      'normalmode = 0
  _Baudrate = 9600                                     'shift levels 9600 times per sec (9600bps)
   
OBJ
   
  Serial: "FullDuplexSerialMod"
  
VAR
  byte  Volume
  
PUB init 

  Volume := 1
  
  Serial.start(_TXPin,_RXPin,_Serialmode,_Baudrate)
  Serial.str(@Init_String)
 
PUB   PlayAll

 Serial.str(@PlayAll_String)

PUB   PlayAll_Repeat

 Serial.str(@PlayAll_Repeat_String)

PUB   PlayAll_Random

 Serial.str(@PlayAll_Random_String)

PUB   Play

 Serial.str(@Play_String)

PUB   Stop

 Serial.str(@Stop_String)
 
PUB   SkipForward

 Serial.str(@SkipForward_String)

PUB   Back

 Serial.str(@Back_String)

'Backs to beginning of current track, or if sent twice within 2 sec, then Vmusic 2 backs to previous track
PUB   Previous

 Serial.str(@Back_String)
 Serial.str(@Back_String)

PUB   Pause

 Serial.str(@Pause_String)

PUB FF

 Serial.str(@FF_String)

PUB REW

 Serial.str(@REW_String)

PUB VolM

 if Volume > 1
    Volume := Volume - 1

 Serial.str(@Vol_String)
 Serial.str(@Volume)
 Serial.str(string(_CR))
 
PUB VolE

 if Volume < 253
    Volume := Volume + 1

 Serial.str(@Vol_String)
 Serial.str(@Volume)
 Serial.str(string(_CR))

DAT
Init_String             byte    "IPH",_CR,0           '' Ehanced command structure, ASCII numbers
Play_String             byte    "VPF",_CR,0           ''NOT CORRECT STRING DOESEN'T WORK set VMUSIC2 to Play current MP3 track  
PlayAll_String          byte    "V3A",_CR,0           '' set VMUSIC2 to Play all MP3 tracks
PlayAll_Repeat_String   byte    "VRA",_CR,0           '' set VMUSIC2 to Play all MP3 tracks and repeat them
PlayAll_Random_String   byte    "VRR",_CR,0           '' set VMUSIC2 to Play all MP3 tracks in ramdon and repeat
Stop_String             byte    "VST",_CR,0           '' set VMUSIC2 to stop playing mp3 tracks
SkipForward_String      byte    "VSF",_CR,0           '' set VMUSIC2 to skip forward to next track  
Back_String             byte    "VSB",_CR,0           '' set VMUSIC2 to back to beginning of track/leading track 
Pause_String            byte     "VP",_CR,0           '' set VMUSIC2 to Pause playback.
FF_String               byte     "VF",_CR,0
REW_String              byte     "VB",_CR,0 
Vol_String              byte    "VSV"," ",0 
   